/*  Example: compile and run this program to find out how your C compiler
treats different data types. The result will depend on the computer and 
compiler you use, and possibly on the compiler settings.
*/

#include <stdio.h>
#include <limits.h>
#include <float.h>

void main(void)
{
  puts("With this computer and compiler, the simple C");
  puts("data types have the following characteristics:\n");

  puts("signed char:");
  printf("\tOccupies %i byte (%i bits)\n", sizeof(signed char), CHAR_BIT);
  printf("\tRanges from %i to %i\n\n", CHAR_MIN, CHAR_MAX);
  
  puts("unsigned char:");
  printf("\tOccupies %i bytes (%i bits)\n", sizeof(unsigned char), CHAR_BIT);
  printf("\tRanges from %i to %i\n\n", 0, UCHAR_MAX);
  
  puts("signed short:");
  printf("\tOccupies %i bytes\n", sizeof(signed short));
  printf("\tRanges from %i to %i\n\n", SHRT_MIN, SHRT_MAX);
  
  puts("unsigned short:");
  printf("\tOccupies %i bytes\n", sizeof(unsigned short));
  printf("\tRanges from %i to %u\n\n", 0, USHRT_MAX);
  
  puts("signed int:");
  printf("\tOccupies %i bytes\n", sizeof(signed int));
  printf("\tRanges from %i to %i\n\n", INT_MIN, INT_MAX);
  
  puts("unsigned int:");
  printf("\tOccupies %i bytes\n", sizeof(unsigned int));
  printf("\tRanges from %i to %u\n\n", 0, UINT_MAX);
  
  puts("signed long:");
  printf("\tOccupies %i bytes\n", sizeof(signed long));
  printf("\tRanges from %li to %li\n\n", LONG_MIN, LONG_MAX);
  
  puts("unsigned long:");
  printf("\tOccupies %i bytes\n", sizeof(unsigned long));
  printf("\tRanges from %i to %lu\n\n", 0, ULONG_MAX);
  
  puts("float:");
  printf("\tOccupies %i bytes\n", sizeof(float));
  printf("\tRanges from +/-(1E%+i to 1E%+i) approx.\n", FLT_MIN_10_EXP, FLT_MAX_10_EXP);
  printf("\tPrecision is %i decimal digits approx.\n\n", FLT_DIG);
  
  puts("double:");
  printf("\tOccupies %i bytes\n", sizeof(double));
  printf("\tRanges from +/-(1E%+i to 1E%+i) approx.\n", DBL_MIN_10_EXP, DBL_MAX_10_EXP);
  printf("\tPrecision is %i decimal digits approx.\n\n", DBL_DIG);
  
  puts("long double:");
  printf("\tOccupies %i bytes\n", sizeof(long double));
  printf("\tRanges from +/-(1E%+i to 1E%+i) approx.\n", LDBL_MIN_10_EXP, LDBL_MAX_10_EXP);
  printf("\tPrecision is %i decimal digits approx.\n\n", LDBL_DIG);
  
  puts("pointer:");
  printf("\tOccupies %i bytes\n", sizeof(void *));
  puts("");
  
  return;
}
